<?php

namespace HS\Http\Controllers\Admin;

use HS\User;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Laravel\Fortify\Actions\DisableTwoFactorAuthentication;

class TwoFactorController extends Controller
{
    /**
     * Disable two factor authentication for a user.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Laravel\Fortify\Actions\DisableTwoFactorAuthentication  $disable
     * @return \Symfony\Component\HttpFoundation\Response
     */
    public function destroy(Request $request, DisableTwoFactorAuthentication $disable)
    {
        if(! auth()->user()->isAdmin() && auth()->user()->getKey() != $request->user) {
            return abort(401);
        }

        // if it's the user who is logged in:
        if (auth()->user()->getKey() === $request->user) {
            $user = auth()->user();
        } else {
            $user = User::find($request->user);
        }

        $disable($user);

        return $request->wantsJson()
                    ? new JsonResponse('', 200)
                    : back()->with('status', 'two-factor-authentication-disabled');
    }
}
