<?php

namespace HS\Http\Csp;

use Spatie\Csp\Keyword;
use Spatie\Csp\Directive;
use Spatie\Csp\Policies\Policy;

class HelpspotPolicy extends Policy
{
    public function configure()
    {
        $this
            ->addDirective(Directive::BASE, Keyword::SELF)
            ->addDirective(Directive::CONNECT, Keyword::SELF.' '. env('CUSTOM_CSP'))
            ->addDirective(Directive::DEFAULT, Keyword::SELF)
            ->addDirective(Directive::FORM_ACTION, Keyword::SELF)
            ->addDirective(Directive::IMG, '* data: blob:')
            ->addDirective(Directive::MEDIA, Keyword::SELF .' '. env('CUSTOM_CSP'))
            ->addDirective(Directive::OBJECT, Keyword::NONE .' '. env('CUSTOM_CSP'))
            ->addDirective(Directive::SCRIPT, "* data: blob: unsafe-inline unsafe-eval" /*Keyword::SELF . ' ' . Keyword::UNSAFE_EVAL*/)
            ->addDirective(Directive::STYLE, Keyword::SELF . ' ' . Keyword::UNSAFE_INLINE . ' ' . 'fonts.googleapis.com '. env('CUSTOM_CSP'))
            ->addDirective(Directive::FONT, Keyword::SELF . ' ' . 'fonts.gstatic.com')
            ->addDirective(Directive::FRAME, Keyword::SELF . ' ' . 'youtube.com www.youtube.com vimeo.com player.vimeo.com '.env('CUSTOM_CSP'));
            // ->addNonceForDirective(Directive::SCRIPT);
            // ->addNonceForDirective(Directive::STYLE);
    }
}
